<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Floating Icon</title>
    <style>
      div.social-float-parent {
        width: 100%;
        height: 4130px;
        background: #f8f8f8;
        position: relative;
      }
      div#social-float {
        width: 200px;
        position: fixed;
        bottom: 10px;
        right: 10px;
        background: #777;
      }
      div#footer {
        width: 100%;
        height: 500px;
        background: #eee;
      }
    </style>
  </head>

  <body>
    <div class="social-float-parent">
      <div id="social-float">float...</div>
    </div>
    <footer>
      <div id="footer"></div>
    </footer>

    <script>
      var socialFloat = document.querySelector("#social-float");
      var footer = document.querySelector("footer");

      function checkOffset() {
        function getRectTop(el) {
          var rect = el.getBoundingClientRect();
          return rect.top;
        }

        if (
          getRectTop(socialFloat) +
            document.body.scrollTop +
            socialFloat.offsetHeight >=
          getRectTop(footer) + document.body.scrollTop - 10
        )
          socialFloat.style.position = "absolute";
        if (
          document.body.scrollTop + window.innerHeight <
          getRectTop(footer) + document.body.scrollTop
        )
          socialFloat.style.position = "fixed"; // restore when you scroll up

        socialFloat.innerHTML = document.body.scrollTop + window.innerHeight;
      }

      document.addEventListener("scroll", function () {
        checkOffset();
      });
    </script>
  </body>
</html>
